Attribute VB_Name = "GetMicroSecModule"
Option Explicit

Private Const BIT56 As Double = 7.20575940379279E+16
Private Const BIT48 As Double = 281474976710656#
Private Const BIT40 As Double = 1099511627776#
Private Const BIT32 As Double = 4294967296#
Private Const BIT24 As Double = 16777216#
Private Const BIT16 As Double = 65536#
Private Const BIT08 As Double = 256#

Public Type LARGE_INTEGER
    BYT(7)  As Byte
'    lowpart As Long
'    highpart As Long
End Type

'x64bits^C}JE^ɃANZXAPI
Public Declare Function QueryPerformanceCounter Lib "kernel32" ( _
                                    lpPerformanceCount As LARGE_INTEGER _
                                                               ) As Long

'x64bits^C}JE^̎g𓾂API
Public Declare Function QueryPerformanceFrequency Lib "kernel32" ( _
                                    lpFrequency As LARGE_INTEGER _
                                                                 ) As Long

Private QPF     As Double           'xptH[}XJE^LSBiʂj
Private Freq    As Double

Private NotEnableQueryPerformaceCounter As Boolean

Public Function GetMicroTime() As Double
    Dim QPC_STA As Long
    Dim Dev     As Double
    Dim QPC     As LARGE_INTEGER
    
    'xptH[}XJE^n[hEFAT|[gĂ
    '        True  T|[g
    '        False T|[g
    Dim NotEnableQueryPerformaceCounter As Boolean
    
    '擾̃^CO邽ߐɌݎ擾Ă
    QPC_STA = QueryPerformanceCounter(QPC)
    
    If (NotEnableQueryPerformaceCounter) Then 'n[hT|[gȂ
        GetMicroTime = 0
    Else
        If (QPF = 0) Then QPF_Init '   W擾ĂȂ
            
        If (QPC_STA <> 0) Then 'n[hT|[gȂ
            Dev = CDbl(QPC.BYT(7)) * BIT56 + _
                  CDbl(QPC.BYT(6)) * BIT48 + _
                  CDbl(QPC.BYT(5)) * BIT40 + _
                  CDbl(QPC.BYT(4)) * BIT32 + _
                  CDbl(QPC.BYT(3)) * BIT24 + _
                  CDbl(QPC.BYT(2)) * BIT16 + _
                  CDbl(QPC.BYT(1)) * BIT08 + _
                  CDbl(QPC.BYT(0))
                        
            Dev = Dev * QPF
        Else
            Dev = 0
        End If
'Debug.Print Deb
        GetMicroTime = Dev
    End If
End Function

Private Sub QPF_Init()
    Dim dmy     As LARGE_INTEGER
    If (QueryPerformanceFrequency(dmy) <> 0) Then
        Freq = CDbl(dmy.BYT(7)) * BIT56 + _
               CDbl(dmy.BYT(6)) * BIT48 + _
               CDbl(dmy.BYT(5)) * BIT40 + _
               CDbl(dmy.BYT(4)) * BIT32 + _
               CDbl(dmy.BYT(3)) * BIT24 + _
               CDbl(dmy.BYT(2)) * BIT16 + _
               CDbl(dmy.BYT(1)) * BIT08 + _
               CDbl(dmy.BYT(0)) 'giHzj
        
        QPF = 1 / (Freq / 1000000#) 'LSB̎ԁiʂj
        NotEnableQueryPerformaceCounter = False
    Else
        NotEnableQueryPerformaceCounter = True
    End If

End Sub
